// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>

#include "colmap.hh"

ColMap::ColMap()
{
  init = false;
}

ColMap::~ColMap()
{
  for(int i=0; i<width; ++i) {
    delete[] ColMap::colmap[i];
  }
  delete[] ColMap::colmap;
}

int
ColMap::load(const char* filename)
{
  init = 1;
  //cout << "Init Colmap" << endl;

  ifstream in(filename);

  if (!in) {
    perror(filename);
    exit(EXIT_FAILURE);
  }

  width = 10;
  height = 10;

  in >> width;
  in >> height;

  // allocate the memory for the colmap
  ColMap::colmap = new int*[width];
  for(int i=0; i<width; ++i) {
    ColMap::colmap[i] = new int[height];
  }

  // load the colmap from file to memory
  int temp;

  for(int y=0; y < height; ++y) {
    for(int x=0; x < width; ++x) {

      // The level file is in RGB format, therefore the value need to 
      // be read in twice
      in >> temp;
      in >> temp;
      in >> temp;

      if (in.eof()) 
	cout << "in::eof" << endl;
      /*      if (temp != 0)
	      cout << "ColMap::not zero" << temp << endl;
	      else
	      cout << "ColMap::zero" << endl;
      */
      ColMap::colmap[x][y] = temp;
      //cout << colmap[x][y] << endl;
    }
  }
  //  cout << "Exit Colmap" << endl;
  //Pingu p(0,0);

  /*

  for(int y=0; y < height; ++y) {
    for(int x=0; x < width; ++x) {
      if (colmap[x][y] == 0)
	p.draw(x,y);
      else if (colmap[x][y] == 255)
	// cout << "ColMap Other Color" << endl;
	{}
      else
	cout << "Uff" << endl;
    }
  }
  */
  //  CL_Display::flip_display();
  //cout << "Totally Finished" << endl;

}

int
ColMap::getpixel(int x, int y)
{
  if (!init) {
    cout << "NOT INIT" << endl;
    exit(1);
  }
  //  return colmap[x][y];

  if (x >= 0 && x < width
      && y >= 0 && y < height) {
    return ColMap::colmap[x][y];
  } else {
    //cout << "Out of Range" << endl;
    return wall;
  }
}

/* EOF */
