// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef PINGUTAIL_HH
#define PINGUTAIL_HH

#include <ClanLib/clanlib.h>
#include "pingutileprovider.hh"

// A PinguTile object manage a single tile of the map, it is basicaly
// only a wrapper for CL_Surface which also manage the animation.

class PinguTile {
private:
  CL_Surface* tile;
  bool redraw;
public:
  PinguTile();
  void draw(int x, int y);
  void load(char*, PinguTileProvider*);
  void load(int i, PinguTileProvider* tile_provider);
  void start_anim();
  void stop_anim();
  bool needs_redraw();
  void set_redraw(bool r);
};

#endif

/* EOF */
