// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

//#include <iostream>
#include <string>
#include <fstream>

#include "plf.hh"

PLF::PLF()
{
  //name = "";
}


PLF::PLF(char* filename)
{
  char token[255];

  bg  = new char[255];
  fg  = new char[255];
  col = new char[255];
  maptype = UNDEF;

  ifstream in(filename);

  if (!in) {
    cout << filename << ":File not found" << endl;
    exit(EXIT_FAILURE);
  }

  while (!in.eof()) {
    in >> token;

    switch (get_token(token)) {
    case BG:
      in >> bg;
      cout << "PLF:" << bg << endl; 
      break;
    case FG:
      in >> fg;
      cout << "PLF:" << fg << endl; 
      break;
    case COL:
      in >> col;
      cout << "PLF:" << col << endl; 
      break;
    case EMPTY:
      break;
    case COMMENT:
      in.ignore(255, '\n');
      break;
    case MAPTYPE:
      in >> token;
      if (strcmp(token, "BMP") == 0) {
	maptype = BMP;
      } else if (strcmp(token, "TILE") == 0) {
	maptype = TILE;
      } else {
	cout << "Syntax Error in PLF file! Wrong maptyp!" << endl;
	exit(EXIT_FAILURE);
      }
      break;
    case UNKNOWN:
      cout << "Syntax Error in PLF file!" << endl;
      exit(EXIT_FAILURE);
      break;
    }
  }
  
  if (maptype == UNDEF) {
    cout << "No maptype set in PLF-file" << endl;
    exit(EXIT_FAILURE);
  }
}

plf_token
PLF::get_token(char* token)
{
  toupper(token);

  if (strcmp(token, "BG:") == 0) {
    return BG;
  } else if (strcmp(token, "FG:") == 0) {
    return FG;
  } else if (strcmp(token, "COL:") == 0) {
    return COL;
  } else if (strcmp(token, "MAPTYPE:") == 0) {
    return MAPTYPE;
  } else if (strcmp(token, "") == 0) {
    return EMPTY;
  } else if (strcmp(token, "//") == 0) {
    return COMMENT;
  }
  return UNKNOWN;
}

const char*
PLF::get_bg()
{
  return bg;
}

const char*
PLF::get_fg()
{
  return fg;
}

const char*
PLF::get_name()
{
  //  return name.c_str();
}

const char*
PLF::get_pngfile()
{
  //  return (filename + ".png").c_str();  
}

MapType
PLF::map_type()
{
  return maptype;
}

char const*
PLF::get_mapfile()
{
  return col;
  //  return "levels/level.pnm";
  //  return (filename + ".map").c_str();
}
/*

PLF::get_descr()
{
}*/

/* EOF */
